#define __OPRDR_H

#ifndef __FSTRM_H
#include "fstrm.h"
#endif


struct pmgrupinfo;

struct pmiteminfo;

class opt                                                           /* op type */
{
   public:

   enum
   {
      mkdir,         deldir,       renfile,      delfile,     copyfile,
      setfileattr,   createfile,   addinientry,  delinientry, setinivalue,
      addgrup,       additem,      delgrup,      delitem,     addregkey, 
      addregfield,   setregfield,  delregfield,  delregkey
   };
};

class oprdr
{
   public:

   virtual void mkdir(char dir[])                                                = 0;
   virtual void deldir(char dir[])                                               = 0;
   virtual void renfile(char oldpath[], char newpath[])                          = 0;
   virtual void delfile(char path[])                                             = 0;
   virtual void copyfile(char srcpath[], char dstpath[], int isshared)           = 0;
   virtual void createfile(char path[])                                          = 0;
   virtual void setfileattr(char path[], DWORD oldflags, DWORD newflags)         = 0;
   virtual void addinientry(char file[], char sect[], char entry[])              = 0;
   virtual void delinientry(char file[], char sect[], char entry[], char oldv[]) = 0;
   virtual void setinivalue(char file[], char sect[], char entry[], char oldv[]) = 0;
   virtual void addgrup(char grup[])                                             = 0;
   virtual void additem(char grup[], char item[])                                = 0;
   virtual void delgrup(char grup[])                                             = 0;
   virtual void delitem(char grup[], pmiteminfo &pmii)                           = 0;
   virtual void addregkey(int kroot, char kpath[])                               = 0;
   virtual void delregkey(int kroot, char kpath[])                               = 0;
   virtual void addregfield(int kroot, char kpath[], char field[])               = 0;
   virtual void setregfield(int kroot, char kpath[], char field[], char oldv[])  = 0;
   virtual void delregfield(int kroot, char kpath[], char field[], char oldv[])  = 0;
};

class voidrdr:public oprdr
{
   public:

   void mkdir(char dir[])
   {

   }
   void deldir(char dir[])
   {

   }
   void renfile(char oldpath[], char newpath[])
   {

   }
   void delfile(char path[])
   {

   }
   void copyfile(char srcpath[], char dstpath[], int isshared)
   {

   }
   void createfile(char path[])
   {

   }
   void setfileattr(char path[], DWORD oldflags, DWORD newflags)
   {

   }
   void addinientry(char file[], char sect[], char entry[])
   {

   }
   void delinientry(char file[], char sect[], char entry[], char oldv[])
   {

   }
   void setinivalue(char file[], char sect[], char entry[], char oldv[])
   {

   }
   void addgrup(char grup[])
   {

   } 
   void additem(char grup[], char item[])
   {

   } 
   void delgrup(char grup[])
   {

   } 
   void delitem(char grup[], pmiteminfo &pmii)
   {

   } 
   void addregkey(int kroot, char kpath[])
   {

   }
   void delregkey(int kroot, char kpath[])
   {

   }
   void addregfield(int kroot, char kpath[], char field[]) 
   {

   }
   void setregfield(int kroot, char kpath[], char field[], char oldv[])
   {

   }
   void delregfield(int kroot, char kpath[], char field[], char oldv[])
   {

   }
};

class logmover
{
   char dstdir[260];

   public:

   logmover(char dstdirx[])
   {
      lstrcpy(dstdir, dstdirx);
   }

   int mvtmp2dst();
   int mvdst2tmp();
};

/* log file. it will be created in the Windows dir. after calling free() */
/* to close the file, we should use logmover to move it to the final dir */
class filog:public oprdr
{
   fstrm f;

   public:

   filog()                                             /* must call init later */
   {

   }
  ~filog()
   {
      free();
   }
   int init(char appname[]);
   void free();
   void mkdir(char dir[]);
   void deldir(char dir[]);
   void renfile(char oldpath[], char newpath[]);
   void delfile(char path[]);
   void copyfile(char srcpath[], char dstpath[], int isshared);
   void createfile(char path[]);
   void setfileattr(char path[], DWORD oldflags, DWORD newflags);
   void addinientry(char file[], char sect[], char entry[]);
   void delinientry(char file[], char sect[], char entry[], char oldv[]);
   void setinivalue(char file[], char sect[], char entry[], char oldv[]);
   void addgrup(char grup[]);
   void additem(char grup[], char item[]); 
   void delgrup(char grup[]); 
   void delitem(char grup[], pmiteminfo &pmii);
   void addregkey(int kroot, char kpath[]);
   void delregkey(int kroot, char kpath[]);
   void addregfield(int kroot, char kpath[], char field[]);
   void setregfield(int kroot, char kpath[], char field[], char oldv[]);
   void delregfield(int kroot, char kpath[], char field[], char oldv[]);
};

